using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace FormulaEngineDefect
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            InitializeGrid();
        }
        private void InitializeGrid()
        {
            gridControl1.SaveCellInfo += new GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
            gridControl1.CellModels.Add("SyncPercentage", new SyncPercent(gridControl1.Model));


            GridStyleInfo newStyle = new GridStyleInfo();
            //add custom property
            SyncStyleProperties sp = new SyncStyleProperties(newStyle);
            Person p = new Person();
            p.FirstName = "Bob";
            p.FirstName = "Dobalina";
            sp.Person = p;
            newStyle.CellType = "SyncPercentage";
            
            gridControl1.Data[3, 3] = newStyle.Store;

            gridControl1[3, 4].Text = @"0.1";
            gridControl1[4, 4].Text = @"0.2";
            gridControl1[3, 2].Text = @"This formula should update if D3 or D4 change >>>";
            gridControl1[3, 3].Text = @"=D3+D4";
            Debug.WriteLine(" 4,4 celltype = " + gridControl1[4, 4].CellType);

            GridFormulaEngine engine = ((GridFormulaCellModel)gridControl1.CellModels["FormulaCell"]).Engine;

            engine.FormulaCopyFlags = GridFormulaCopyFlags.ClipBoardFormula |
                                        GridFormulaCopyFlags.ClipBoardReferencesAdjusted |
                                        GridFormulaCopyFlags.InsDelRangeReferencesUpdated |
                                        GridFormulaCopyFlags.NamedRangeReferencesUpdated;

        }

        void gridControl1_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
        {
            Debug.WriteLine("SaveCellInfo fired for " + e.Style.CellIdentity );
            object saveValue;
            Person person = ((SyncStyleProperties)e.Style).Person;
            if (person != null)
            {
                ///Remember that .Value should always get/set the absolute value of the model.
                if (e.Style.CellValue.ToString().StartsWith("="))
                {
                    //Formulae result is always absolute value (e.g. 10 percent will always be returned as 0.10).
                    //Set actual value of model and let the cell model handle display.

                    person.TestScoreAbsolute = Double.Parse(e.Style.FormattedText);

                    saveValue = person.TestScoreAbsolute;
                }
                else
                {
                    //otherwise the user enters the value in accordance with what they see (e.g. 10 percent as 10.0)
                    double temp = 0.0;
                    if (double.TryParse(e.Style.CellValue.ToString(),out temp))
                    {
                        person.TestScorePercentage = temp;
                        saveValue = person.TestScorePercentage;
                    }
                }

                Debug.WriteLine("SaveCellInfo for cell ID: " + e.Style.CellIdentity.Info + " e.Style.Text = " + e.Style.Text);
                Debug.WriteLine("SaveCellInfo  for cell ID: " + e.Style.CellIdentity.Info + " e.Style.CellValue = " + e.Style.CellValue);
                Debug.WriteLine("SaveCellInfo  for cell ID: " + e.Style.CellIdentity.Info + " e.Style.FormattedText (saved) = " + e.Style.FormattedText);
            }
        }

        private void gridControl1_CellClick(object sender, GridCellClickEventArgs e)
        {

        }
    }
}