using Syncfusion.Windows.Forms.Grid;
using System;

namespace FormulaEngineDefect
{
    public class SyncPercent : GridFormulaCellModel
    {
        protected SyncPercent(System.Runtime.Serialization.SerializationInfo info,
                             System.Runtime.Serialization.StreamingContext context)
            : base(info, context)
        {
        }

        public SyncPercent(GridModel grid)
            : base(grid)
        {
        }

        public override GridCellRendererBase CreateRenderer(GridControlBase control)
        {
            return new SyncDoubleRenderer(control, this);
        }
    }

    public class SyncDoubleRenderer : GridFormulaCellRenderer
    {
        public SyncDoubleRenderer(GridControlBase grid, SyncPercent cellModel)
            : base(grid, cellModel)
        {
        }

        public override void OnPrepareViewStyleInfo(GridPrepareViewStyleInfoEventArgs e)
        {
            Person person = ((SyncStyleProperties) (e.Style)).Person;
            //removing this line means that gridControl1_SaveCellInfo event is fired
            e.Style.Text = (person.TestScorePercentage).ToString("00.00");
            base.OnPrepareViewStyleInfo(e);
        }
    }

}
